export declare function debounce<T extends (...args: any[]) => any>(func: T, delay: number): (...args: Parameters<T>) => void;
mber;
    left: number;
    width: number;
    height: number;
}
export type Keyword = string | string[];
type CSSProperties = {
    [key in string]: string;
};
type HighlightItMode = 'single' | 'all';
export interface HighlightItOptions {
    /**
     * auto append the highlight block to element
     * @default false
     */
    appendToElement: boolean;
    /**
     * element position
     * @default 'relative'
     */
    rootElementPosition: string;
    /**
     * highlight block position
     * @default 'absolute'
     */
    highlightElementPosition: string;
    /**
     * position processor
     * @param position highlight block position(before)
     * @returns highlight block position(after)
     */
    positionProcessor?: (position: HighlightBlockPosition) => HighlightBlockPosition;
    /**
     * highlight block element
     * @default 'div'
     */
    highlightElement: string;
    /**
     * highlight block element class
     * @default 'highlight-it'
     */
    highlightClassName: string;
    /**
     * highlight block element class style
     * @default {}
     */
    highlightStyle: CSSProperties;
    /**
     * 'single' only highlight one, 'all' highlight all. when keyword is array, only can highlight all.
     * @default 'single'
     */
    mode: HighlightItMode;
    /**
     * when observe element, debounce time
     * @default 0
     */
    delay: number;
}
export interface HighlightBlocks {
    count: number;
    blocks: HighlightBlockPosition[][];
}
export default class HighlightIt {
    element: Element;
    options: HighlightItOptions;
    resizeObserver: ResizeObserver | null;
    keyword: string | string[];
    highlightBlocks: HighlightBlocks | HighlightBlocks[];
    highlightBlockElements: Element[];
    currentIndex: number;
    currentBlock: HighlightBlockPosition[];
    constructor(element: Element, options?: Partial<HighlightItOptions>);
    setOptions(options: Partial<HighlightItOptions>): void;
    update(): HighlightBlockPosition[];
    query(keyword: Keyword): HighlightBlockPosition[];
    clearBlocks(): void;
    appendBlocks(blocks: HighlightBlockPosition[]): void;
    prev(): HighlightBlockPosition[];
    next(): HighlightBlockPosition[];
    observe(): void;
    unobserve(): void;
}
export {};
